package org.amse.chekh.paint_graph.abstact_view.impl;

import java.awt.Color;

import org.amse.chekh.paint_graph.abstact_view.IGraph;
import org.amse.chekh.paint_graph.abstact_view.IGraphProperties;
import org.amse.chekh.paint_graph.model.IFunction;

/**
 *       :    
 * 
 * @author 
 * 
 */
class Graph implements IGraph {

	/**
	 *   
	 */
	private GraphProperties myGraphProperties;

	/**
	 *    
	 */
	private IFunction myFunction;

	/**
	 *     
	 */
	private boolean myGraphPaint;

	/**
	 *    
	 */
	private boolean myGraphSelected;

	/**
	 *   
	 * 
	 * @param graphProperties -
	 *             
	 * @param function -
	 *            
	 */
	Graph(IFunction function) {
		this.myFunction = function;
		this.myGraphSelected = false;
	}

	public IFunction getFunction() {
		return this.myFunction;
	}

	public IGraphProperties getProperties() {
		return this.myGraphProperties;
	}

	void setProperties(double minX, double maxX, int countOfSegment,
			Color color) {
		this.myGraphProperties = new GraphProperties(minX, maxX,
				countOfSegment, color);
	}

	public boolean isGraphPaint() {
		return this.myGraphPaint;
	}

	void setGraphPaint(boolean isPaint) {
		this.myGraphPaint = isPaint;
	}

	public boolean isGraphSelected() {
		return this.myGraphSelected;
	}

	void changeGraphSelected() {
		this.myGraphSelected = !this.myGraphSelected;
	}

	/**
	 *     
	 * 
	 * @author 
	 * 
	 */
	private class GraphProperties implements IGraphProperties {

		/**
		 *   X   
		 */
		private double myMinX;

		/**
		 *   X   
		 */
		private double myMaxX;

		/**
		 *   ,     
		 * 
		 */
		private int myCountOfSegment;

		/**
		 * ,     
		 */
		private Color myColor;

		/**
		 *   
		 * 
		 * @param minX -
		 *              X
		 * @param maxX -
		 *              X
		 * @param countOfSegment -
		 *             
		 * @param color -
		 *             
		 */
		private GraphProperties(double minX, double maxX, int countOfSegment,
				Color color) {
			this.myMinX = minX;
			this.myMaxX = maxX;
			this.myCountOfSegment = countOfSegment;
			this.myColor = color;
		}

		public double getMinimumX() {
			return this.myMinX;
		}

		public double getMaximumX() {
			return this.myMaxX;
		}

		public int getCountOfSegment() {
			return this.myCountOfSegment;
		}
		
		public Color getColor() {
			return this.myColor;
		}

	}

}
