package org.amse.chekh.paint_graph.io.reader;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import org.amse.chekh.paint_graph.abstact_view.IGraph;
import org.amse.chekh.paint_graph.abstact_view.impl.GraphFactory;
import org.amse.chekh.paint_graph.model.IFunction;
import org.amse.chekh.paint_graph.model.impl.FunctionFactory;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 *         
 * 
 * @author 
 * 
 */
class MyHandler extends DefaultHandler {

	/**
	 *   
	 */
	private List<IGraph> myGraphs;

	/**
	 *   
	 */
	private String myCurrentFunction;

	/**
	 *      
	 */
	private boolean myCurrentGrahIsPaint;

	/**
	 *     X
	 */
	private double myMinX;

	/**
	 *     X
	 */
	private double myMaxX;

	/**
	 *    
	 */
	private int myCountOfSegment;

	/**
	 *      
	 */
	private Color myColor;

	private double myMinVisibleX;

	private double myMinVisibleY;

	private double myMaxVisibleY;

	private double myMaxVisibleX;

	/**
	 *        
	 */
	MyHandler() {
	}

	@Override
	public void startElement(String uri, String localName, String qName,
			org.xml.sax.Attributes atts) throws SAXException {
		if (qName.equals("graphs")) {
			this.myGraphs = new ArrayList<IGraph>(Integer.parseInt(atts
					.getValue("count")));
		} else if (qName.equals("minimum_Visible_X")) {
			this.myMinVisibleX = Double.parseDouble(atts.getValue("value"));
		} else if (qName.equals("maximum_Visible_X")) {
			this.myMaxVisibleX = Double.parseDouble(atts.getValue("value"));
		} else if (qName.equals("minimum_Visible_Y")) {
			this.myMinVisibleY = Double.parseDouble(atts.getValue("value"));
		} else if (qName.equals("maximum_Visible_Y")) {
			this.myMaxVisibleY = Double.parseDouble(atts.getValue("value"));
		} else if (qName.equals("graph")) {
			this.myCurrentFunction = atts.getValue("function").substring(2);
		} else if (qName.equals("minimum_X")) {
			this.myMinX = Double.parseDouble(atts.getValue("value"));
		} else if (qName.equals("maximum_X")) {
			this.myMaxX = Double.parseDouble(atts.getValue("value"));
		} else if (qName.equals("count_of_segment")) {
			this.myCountOfSegment = Integer.parseInt(atts.getValue("value"));
		} else if (qName.equals("color")) {
			String s = atts.getValue("value");
			if (s.equals("black")) {
				this.myColor = Color.BLACK;
			} else if (s.equals("red")) {
				this.myColor = Color.RED;
			} else if (s.equals("green")) {
				this.myColor = Color.GREEN;
			} else if (s.equals("blue")) {
				this.myColor = Color.BLUE;
			} else if (s.equals("yellow")) {
				this.myColor = Color.YELLOW;
			} else {
				this.myColor = null;
			}
		} else if (qName.equals("isPaint")) {
			this.myCurrentGrahIsPaint = Boolean.parseBoolean(atts
					.getValue("value"));
		}
	}

	@Override
	public void endElement(String uri, String localName, String qName)
			throws SAXException {
		if (qName.equals("graph")) {
			IFunction f = FunctionFactory
					.createFunction(this.myCurrentFunction);
			IGraph graph = GraphFactory.createGraph(f, this.myMinX,
					this.myMaxX, this.myCountOfSegment, this.myColor,
					this.myCurrentGrahIsPaint);
			this.myGraphs.add(graph);
		}
	}

	/**
	 * @return   
	 */
	List<IGraph> graphs() {
		return this.myGraphs;
	}
	
	double getMinimunVisibleX() {
		return this.myMinVisibleX;
	}

	double getMinimunVisibleY() {
		return this.myMinVisibleY;
	}

	double getMaximunVisibleX() {
		return this.myMaxVisibleX;
	}

	double getMaximunVisibleY() {
		return this.myMaxVisibleY;
	}

}
