package org.amse.chekh.paint_graph.io.reader;

import java.io.IOException;
import java.util.List;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.amse.chekh.paint_graph.abstact_view.IGraph;
import org.xml.sax.SAXException;

/**
 *     
 * 
 * @author 
 * 
 */
public class Reader {

	/**
	 *     
	 */
	private String myFileName;

	/**
	 *    XML   
	 */
	private MyHandler myHandler;

	/**
	 *        
	 * 
	 * @param fileName -
	 *                
	 */
	public Reader(String fileName) {
		this.myFileName = fileName;
		this.myHandler = new MyHandler();
	}

	/**
	 *    ,       
	 * 
	 * @return    (    ) 
	 *          
	 * @exception ParserConfigurationException
	 * @exception SAXException
	 * @exception IOException
	 */
	public List<IGraph> read() throws ParserConfigurationException,
			SAXException, IOException {
		SAXParser parser = SAXParserFactory.newInstance().newSAXParser();
		parser.parse(this.myFileName, this.myHandler);
		return this.myHandler.graphs();
	}
	
	public double getMinimunVisibleX() {
		return this.myHandler.getMinimunVisibleX();
	}

	public double getMinimunVisibleY() {
		return this.myHandler.getMinimunVisibleY();
	}

	public double getMaximunVisibleX() {
		return this.myHandler.getMaximunVisibleX();
	}

	public double getMaximunVisibleY() {
		return this.myHandler.getMaximunVisibleY();
	}
	
}
