package org.amse.chekh.paint_graph.model.bintree.node.binary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;

/**
 *      
 * 
 * @author 
 */
public abstract class BinaryFunctionNode extends AbstractNode {

	/**
	 *    
	 */
	protected AbstractNode myFirstArgument;

	/**
	 *    
	 */
	protected AbstractNode mySecondArgument;

	@Override
	public boolean canEvaluate(double x) {
		double evaluatedFirstArgument = this.myFirstArgument.evaluate(x);
		if (Double.isNaN(evaluatedFirstArgument)) {
			return false;
		}
		double evaluatedSecondArgument = this.mySecondArgument.evaluate(x);
		if (Double.isNaN(evaluatedSecondArgument)) {
			return false;
		}
		return this.canEvaluateInternal(evaluatedFirstArgument,
				evaluatedSecondArgument);
	}

	/**
	 * ,        
	 * 
	 * 
	 * @param firstArgument -
	 *               
	 * @param secondArgument -
	 *               
	 * @return     
	 */
	abstract boolean canEvaluateInternal(double firstArgument,
			double secondArgument);

	@Override
	public double evaluate(double x) {
		double evaluatedFirstArgument = this.myFirstArgument.evaluate(x);
		if (Double.isNaN(evaluatedFirstArgument)) {
			return Double.NaN;
		}
		double evaluatedSecondArgument = this.mySecondArgument.evaluate(x);
		if (Double.isNaN(evaluatedSecondArgument)) {
			return Double.NaN;
		}
		return this.calculate(evaluatedFirstArgument, evaluatedSecondArgument);
	}

	/**
	 *       
	 * 
	 * @param firstArgument -
	 *               
	 * @param secondArgument -
	 *               
	 * @return  
	 */
	abstract double calculate(double firstArgument, double secondArgument);

	@Override
	public abstract String getFunction();

}
