package org.amse.chekh.paint_graph.model.bintree.node.binary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;

/**
 *    
 * 
 * @author 
 */
public class MinusNode extends BinaryFunctionNode {

	public MinusNode(AbstractNode firstArgument, AbstractNode secondArgument) {
		this.myFirstArgument = firstArgument;
		this.mySecondArgument = secondArgument;
	}

	@Override
	public double calculate(double firstArgument, double secondArgument) {
		return (firstArgument - secondArgument);
	}

	@Override
	boolean canEvaluateInternal(double firstArgument, double secondArgument) {
		return true;
	}

	@Override
	public String getFunction() {
		StringBuffer text = new StringBuffer();
		text.append(this.myFirstArgument.getFunction());
		text.append("-");
		if (this.mySecondArgument instanceof PlusNode
				|| this.mySecondArgument instanceof MinusNode) {
			text.append("(");
			text.append(this.mySecondArgument.getFunction());
			text.append(")");
		} else {
			text.append(this.mySecondArgument.getFunction());
		}
		return text.toString();
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffFirstArgument = this.myFirstArgument.getDifferencial();
		AbstractNode diffSecondArgument = this.mySecondArgument
				.getDifferencial();
		if (diffSecondArgument == AbstractNode.ZERO_NODE) {
			return diffFirstArgument;
		} else {
			return new MinusNode(diffFirstArgument, diffSecondArgument);
		}
	}

}
