package org.amse.chekh.paint_graph.model.bintree.node.binary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;

/**
 *    
 * 
 * @author 
 */
public class PlusNode extends BinaryFunctionNode {

	public PlusNode(AbstractNode firstArgument, AbstractNode secondArgument) {
		this.myFirstArgument = firstArgument;
		this.mySecondArgument = secondArgument;
	}

	@Override
	public double calculate(double firstArgument, double secondArgument) {
		return (firstArgument + secondArgument);
	}

	@Override
	boolean canEvaluateInternal(double firstArgument, double secondArgument) {
		return true;
	}

	@Override
	public String getFunction() {
		StringBuffer text = new StringBuffer();
		text.append(this.myFirstArgument.getFunction());
		text.append("+");
		text.append(this.mySecondArgument.getFunction());
		return text.toString();
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffFirstArgument = this.myFirstArgument.getDifferencial();
		AbstractNode diffSecondArgument = this.mySecondArgument.getDifferencial();
		if (diffFirstArgument == AbstractNode.ZERO_NODE) {
			return diffSecondArgument;
		} else if (diffSecondArgument == AbstractNode.ZERO_NODE) {
			return diffFirstArgument;
		} else {
			return new PlusNode(diffFirstArgument, diffSecondArgument);
		}
	}

}
