package org.amse.chekh.paint_graph.model.bintree.node.binary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;

/**
 *    
 * 
 * @author 
 */
public class ProductNode extends BinaryFunctionNode {

	public ProductNode(AbstractNode firstArgument, AbstractNode secondArgument) {
		this.myFirstArgument = firstArgument;
		this.mySecondArgument = secondArgument;
	}

	@Override
	public double calculate(double firstArgument, double secondArgument) {
		return (firstArgument * secondArgument);
	}

	@Override
	boolean canEvaluateInternal(double firstArgument, double secondArgument) {
		return true;
	}

	@Override
	public String getFunction() {
		StringBuffer text = new StringBuffer();
		if (this.myFirstArgument instanceof PlusNode
				|| this.myFirstArgument instanceof MinusNode) {
			text.append("(");
			text.append(this.myFirstArgument.getFunction());
			text.append(")");
		} else {
			text.append(this.myFirstArgument.getFunction());
		}
		text.append("*");
		if (this.mySecondArgument instanceof PlusNode
				|| this.mySecondArgument instanceof MinusNode) {
			text.append("(");
			text.append(this.mySecondArgument.getFunction());
			text.append(")");
		} else {
			text.append(this.mySecondArgument.getFunction());
		}
		return text.toString();
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffFirstArgument = this.myFirstArgument.getDifferencial();
		AbstractNode diffSecondArgument = this.mySecondArgument
				.getDifferencial();
		AbstractNode first, second;
		if (diffFirstArgument == AbstractNode.ZERO_NODE) {
			first = AbstractNode.ZERO_NODE;
		} else if (diffFirstArgument == AbstractNode.ONE_NODE) {
			first = this.mySecondArgument;
		} else {
			first = new ProductNode(this.mySecondArgument, diffFirstArgument);
		}
		if (diffSecondArgument == AbstractNode.ZERO_NODE) {
			second = AbstractNode.ZERO_NODE;
		} else if (diffSecondArgument == AbstractNode.ONE_NODE) {
			second = this.myFirstArgument;
		} else {
			second = new ProductNode(this.myFirstArgument, diffSecondArgument);
		}
		if (first == AbstractNode.ZERO_NODE) {
			return second;
		} else if (second == AbstractNode.ZERO_NODE) {
			return first;
		} else {
			return new PlusNode(first, second);
		}
	}

}