package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.exception.DifferencialException;
import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;

/**
 *    <b></b>
 * 
 * @author 
 */
public class AbsNode extends UnaryFunctionNode {

	public AbsNode(AbstractNode argument) {
		this.myArgument = argument;
	}

	@Override
	public double calculate(double t) {
		return Math.abs(t);
	}

	@Override
	boolean canEvaluateInternal(double t) {
		return true;
	}

	@Override
	public String getFunction() {
		return "abs(" + this.myArgument.getFunction() + ")";
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffArgument = this.myArgument.getDifferencial();
		if (diffArgument == AbstractNode.ZERO_NODE) {
			return AbstractNode.ZERO_NODE;
		} else {
			throw new DifferencialException(
					" ABS(f(x))   ");
		}
	}

}
