package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;
import org.amse.chekh.paint_graph.model.bintree.node.ConstantNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.DivideNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.PlusNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.PowerNode;

/**
 *    <b>-</b>
 * 
 * @author 
 */
public class AtanNode extends UnaryFunctionNode {

	public AtanNode(AbstractNode argument) {
		this.myArgument = argument;
	}

	@Override
	public double calculate(double t) {
		return Math.atan(t);
	}

	@Override
	boolean canEvaluateInternal(double t) {
		return true;
	}

	@Override
	public String getFunction() {
		return "atan(" + this.myArgument.getFunction() + ")";
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffArgument = this.myArgument.getDifferencial();
		if (diffArgument == AbstractNode.ZERO_NODE) {
			return AbstractNode.ZERO_NODE;
		} else {
			AbstractNode diffNode = new PlusNode(AbstractNode.ONE_NODE,
					new PowerNode(this, new ConstantNode(2.0)));
			if (diffArgument == AbstractNode.ONE_NODE) {
				return new DivideNode(AbstractNode.ONE_NODE, diffNode);
			} else {
				return new DivideNode(diffArgument, diffNode);
			}
		}
	}

}