package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.MinusNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.ProductNode;

/**
 *    <b></b>
 * 
 * @author 
 */
public class CosNode extends UnaryFunctionNode {

	public CosNode(AbstractNode argument) {
		this.myArgument = argument;
	}

	@Override
	public double calculate(double t) {
		return Math.cos(t);
	}

	@Override
	boolean canEvaluateInternal(double t) {
		return true;
	}

	@Override
	public String getFunction() {
		return "cos(" + this.myArgument.getFunction() + ")";
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffArgument = this.myArgument.getDifferencial();
		if (diffArgument == AbstractNode.ZERO_NODE) {
			return AbstractNode.ZERO_NODE;
		} else if (diffArgument == AbstractNode.ONE_NODE) {
				return new MinusNode(AbstractNode.ZERO_NODE, new SinNode(
						this.myArgument));
		} else {
			return new MinusNode(AbstractNode.ZERO_NODE, new ProductNode(
					diffArgument, new SinNode(this.myArgument)));
		}
	}

}
