package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.DivideNode;

/**
 *    <b> </b>
 * 
 * @author 
 */
public class LnNode extends UnaryFunctionNode {

	public LnNode(AbstractNode argument) {
		this.myArgument = argument;
	}

	@Override
	public double calculate(double t) {
		if (this.canEvaluateInternal(t)) {
			return Math.log(t);
		} else {
			return Double.NaN;
		}
	}

	@Override
	boolean canEvaluateInternal(double t) {
		return t > 0;
	}

	@Override
	public String getFunction() {
		return "ln(" + this.myArgument.getFunction() + ")";
	}
	
	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffArgument = this.myArgument.getDifferencial();
		if (diffArgument == AbstractNode.ZERO_NODE) {
			return AbstractNode.ZERO_NODE;
		} else if (diffArgument == AbstractNode.ONE_NODE) {
			return new DivideNode(AbstractNode.ONE_NODE, this.myArgument);
		} else {
			return new DivideNode(diffArgument, this.myArgument);
		}
	}
	
}
