package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.ProductNode;

/**
 *    <b></b>
 * 
 * @author 
 */
public class SinNode extends UnaryFunctionNode {

	public SinNode(AbstractNode argument) {
		this.myArgument = argument;
	}

	@Override
	public double calculate(double t) {
		return Math.sin(t);
	}

	@Override
	boolean canEvaluateInternal(double t) {
		return true;
	}

	@Override
	public String getFunction() {
		return "sin(" + this.myArgument.getFunction() + ")";
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffArgument = this.myArgument.getDifferencial();
		if (diffArgument == AbstractNode.ZERO_NODE) {
			return AbstractNode.ZERO_NODE;
		} else if (diffArgument == AbstractNode.ONE_NODE) {
				return new CosNode(this.myArgument);
		} else {
			return new ProductNode(diffArgument, new CosNode(
					this.myArgument));
		}
	}

}
