package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;
import org.amse.chekh.paint_graph.model.bintree.node.ConstantNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.DivideNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.ProductNode;

/**
 *    <b> </b>
 * 
 * @author 
 */
public class SqrtNode extends UnaryFunctionNode {

	public SqrtNode(AbstractNode argument) {
		this.myArgument = argument;
	}

	@Override
	public double calculate(double t) {
		if (this.canEvaluateInternal(t)) {
			return Math.sqrt(t);
		} else {
			return Double.NaN;
		}
	}

	@Override
	boolean canEvaluateInternal(double t) {
		return t >= 0;
	}

	@Override
	public String getFunction() {
		return "sqrt(" + this.myArgument.getFunction() + ")";
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffArgument = this.myArgument.getDifferencial();
		if (diffArgument == AbstractNode.ZERO_NODE) {
			return AbstractNode.ZERO_NODE;
		} else if (diffArgument == AbstractNode.ONE_NODE) {
				return new DivideNode(new ConstantNode(0.5), this);
		} else {
			return new ProductNode(new ProductNode(new ConstantNode(0.5),
					diffArgument), this);
		}
	}

}
