package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;
import org.amse.chekh.paint_graph.model.bintree.node.ConstantNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.DivideNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.PowerNode;

/**
 *    <b></b>
 * 
 * @author 
 */
public class TanNode extends UnaryFunctionNode {

	public TanNode(AbstractNode argument) {
		this.myArgument = argument;
	}

	@Override
	public double calculate(double t) {
		if (this.canEvaluateInternal(t)) {
			return Math.tan(t);
		} else {
			return Double.NaN;
		}
	}

	@Override
	boolean canEvaluateInternal(double t) {
		return Math.abs(t + Math.PI / 2) % Math.PI != 0.0;
	}

	@Override
	public String getFunction() {
		return "tan(" + this.myArgument.getFunction() + ")";
	}

	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffArgument = this.myArgument.getDifferencial();
		if (diffArgument == AbstractNode.ZERO_NODE) {
			return AbstractNode.ZERO_NODE;
		} else if (diffArgument == AbstractNode.ONE_NODE) {
				return new PowerNode(new CosNode(this.myArgument), new ConstantNode(-2.0));
		} else {
				return new DivideNode(diffArgument, new PowerNode(
						new CosNode(this.myArgument), new ConstantNode(2.0)));
		}
	}

}
