package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;
import org.amse.chekh.paint_graph.model.bintree.node.ConstantNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.DivideNode;
import org.amse.chekh.paint_graph.model.bintree.node.binary.PowerNode;

/**
 *    <b> </b>
 * 
 * @author 
 */
public class TanhNode extends UnaryFunctionNode {

	public TanhNode(AbstractNode argument) {
		this.myArgument = argument;
	}

	@Override
	public double calculate(double t) {
		return Math.tanh(t);
	}

	@Override
	boolean canEvaluateInternal(double t) {
		return true;
	}

	@Override
	public String getFunction() {
		return "tanh(" + this.myArgument.getFunction() + ")";
	}
	
	@Override
	public AbstractNode getDifferencial() {
		AbstractNode diffArgument = this.myArgument.getDifferencial();
		if (diffArgument == AbstractNode.ZERO_NODE) {
			return AbstractNode.ZERO_NODE;
		} else if (diffArgument == AbstractNode.ONE_NODE) {
				return new PowerNode(new CoshNode(this.myArgument), new ConstantNode(-2.0));
		} else {
				return new DivideNode(diffArgument, new PowerNode(
						new CoshNode(this.myArgument), new ConstantNode(2.0)));
		}
	}
	
}
