package org.amse.chekh.paint_graph.model.bintree.node.unary;

import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;

/**
 *    -    
 * 
 * @author 
 */
public abstract class UnaryFunctionNode extends AbstractNode {

	/**
	 *   
	 */
	protected AbstractNode myArgument;

	@Override
	public boolean canEvaluate(double x) {
		double t = this.evaluate(x);
		return !Double.isNaN(t);
	}

	/**
	 * ,        
	 * 
	 * 
	 * @param t -
	 *              
	 * @return     
	 */
	abstract boolean canEvaluateInternal(double t);

	@Override
	public double evaluate(double x) {
		double t = this.myArgument.evaluate(x);
		if (Double.isNaN(t)) {
			return Double.NaN;
		} else {
			return this.calculate(t);
		}
	}

	/**
	 *       
	 * 
	 * @param t -
	 *              
	 * @return  
	 */
	abstract double calculate(double t);

	@Override
	public abstract String getFunction();

}
