package org.amse.chekh.paint_graph.model.bintree.token;

/**
 *    .       Enum
 * TypeOfToken
 * 
 * @author 
 * 
 */
public class Token {

	/**
	 *  
	 */
	private final String myText;

	/**
	 *  
	 */
	private final TypeOfToken myType;

	/**
	 * ,    
	 * 
	 * @param text -
	 *             
	 * @param type -
	 *             
	 */
	Token(String text, TypeOfToken type) {
		this.myText = text;
		this.myType = type;
	}

	/**
	 * @return     
	 */
	boolean isSignum() {
		return this.myType == TypeOfToken.SIGNUM;
	}

	/**
	 * @return     
	 */
	public boolean isVariable() {
		return this.myType == TypeOfToken.VARIABLE;
	}

	/**
	 * @return     
	 */
	boolean isNumber() {
		return this.myType == TypeOfToken.NUMBER;
	}

	/**
	 * @return     
	 */
	public boolean isFunction() {
		return this.myType == TypeOfToken.FUNCTION;
	}

	/**
	 * @return      
	 */
	public boolean isOpenBrace() {
		return this.myText.equals("(");
	}

	/**
	 * @return      
	 */
	public boolean isCloseBrace() {
		return this.myText.equals(")");
	}

	/**
	 * @return      
	 */
	public boolean isPlus() {
		return this.myText.equals("+");
	}

	/**
	 * @return      
	 */
	public boolean isMinus() {
		return this.myText.equals("-");
	}

	/**
	 * @return      
	 */
	public boolean isProduct() {
		return this.myText.equals("*");
	}

	/**
	 * @return      
	 */
	public boolean isDivide() {
		return this.myText.equals("/");
	}

	/**
	 * @return      
	 */
	public boolean isPower() {
		return this.myText.equals("^");
	}

	/**
	 * @return    (   - ) 
	 */
	public double getNumber() {
		return Double.parseDouble(this.myText);
	}

	/**
	 * @return  
	 */
	public String getText() {
		return this.myText;
	}

}
