package org.amse.chekh.paint_graph.model.impl;

import org.amse.chekh.paint_graph.exception.ParseTreeException;
import org.amse.chekh.paint_graph.model.IFunction;
import org.amse.chekh.paint_graph.model.bintree.BinTreeCreator;
import org.amse.chekh.paint_graph.model.bintree.node.AbstractNode;

/**
 *      
 * 
 * @author 
 */
class Function implements IFunction {

	/**
	 *  
	 */
	private String myText;

	/**
	 * ,  
	 */
	private AbstractNode myHeadNode;

	/**
	 *     (    -  
	 * ),      
	 */
	private String myException = "";

	/**
	 *   
	 * 
	 * @param text -
	 *             
	 */
	Function(String text) {
		this.myText = text;
	}

	/**
	 *     
	 */
	void parse() {
		try {
			this.myHeadNode = new BinTreeCreator(this.myText).createBinTree();
		} catch (ParseTreeException ex) {
			this.myHeadNode = null;
			this.myException = ex.getMessage();
		}
	}

	public boolean canEvaluate(double x) {
		if (!this.isValid()) {
			return false;
		}
		return this.myHeadNode.canEvaluate(x);
	}

	public double evaluate(double x) {
		if (!this.canEvaluate(x)) {
			return Double.NaN;
		}
		return this.myHeadNode.evaluate(x);
	}

	public String getText() {
		return this.myText;
	}

	public boolean isValid() {
		return this.myHeadNode != null;
	}

	public String getErrorMessage() {
		return this.myException;
	}

	public IFunction getDifferencial() {
		if (!this.isValid()) {
			return null;
		}
		AbstractNode diff = this.myHeadNode.getDifferencial();
		Function f = new Function(diff.getFunction());
		f.myHeadNode = diff;
		return f;
	}

}
