package org.amse.chekh.paint_graph.tests.absract_view_tests;

import java.util.ArrayList;
import java.util.List;

import org.amse.chekh.paint_graph.abstact_view.IAbstractView;
import org.amse.chekh.paint_graph.abstact_view.IGraph;
import org.amse.chekh.paint_graph.abstact_view.impl.AbstractViewFactory;
import org.amse.chekh.paint_graph.abstact_view.impl.GraphFactory;
import org.amse.chekh.paint_graph.model.impl.FunctionFactory;

import junit.framework.TestCase;

public class ChangeGraphTests extends TestCase {

	private String[] functions = { "1.0", "x", "x*x", "x^x", "x/x", "x+x",
			"x-x", "sin(x)" };
	
	public void test1() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		List<IGraph> result = new ArrayList<IGraph>();
		IGraph g1 = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[0]), 0, 0, 0, null, true);
		result.add(g1);
		IGraph g2 = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[1]), 0, 2, 0, null, false);
		g1 = result.remove(0);
		result.add(0, g2);
		view.changeGraph(g1, g2);
		List<IGraph> list = view.graphs();
		assertEquals(result, list);
	}

	public void test2() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		List<IGraph> result = new ArrayList<IGraph>();
		IGraph g = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[0]), 0, 0, 0, null, true);
		result.add(g);
		view.addGraph(g);
		g = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[2]), 0, 0, 0, null, true);
		result.add(g);
		view.addGraph(g);
		g = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[3]), 0, 0, 0, null, false);
		IGraph g2 = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[1]), 0, 2, 0, null, false);
		g = result.remove(1);
		result.add(1, g2);
		view.changeGraph(g, g2);
		List<IGraph> list = view.graphs();
		assertEquals(result, list);
	}
	
}
