package org.amse.chekh.paint_graph.tests.absract_view_tests;

import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.amse.chekh.paint_graph.abstact_view.IAbstractView;
import org.amse.chekh.paint_graph.abstact_view.IGraph;
import org.amse.chekh.paint_graph.abstact_view.impl.AbstractViewFactory;
import org.amse.chekh.paint_graph.abstact_view.impl.GraphFactory;
import org.amse.chekh.paint_graph.model.impl.FunctionFactory;

public class RemoveGraphTests extends TestCase {

	private String functions[] = { "1.0", "x", "x*x", "x^x", "x/x", "x+x",
			"x-x", "sin(x)" };

	public void test1() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		List<IGraph> result = new ArrayList<IGraph>();
		IGraph g = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[0]), 0, 0, 0, null, true);
		result.add(g);
		view.addGraph(g);
		IGraph graph = result.get(0);
		result.remove(graph);
		view.removeGraph(graph);
		List<IGraph> list = view.graphs();
		assertEquals(result, list);
	}

	public void test2() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		List<IGraph> result = new ArrayList<IGraph>();
		IGraph g = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[0]), 0, 0, 0, null, true);
		result.add(g);
		view.addGraph(g);
		g = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[2]), 0, 0, 0, null, true);
		result.add(g);
		view.addGraph(g);
		g = GraphFactory.createGraph(FunctionFactory
				.createFunction(functions[3]), 0, 0, 0, null, true);
		result.add(g);
		view.addGraph(g);
		IGraph graph = result.get(0);
		result.remove(graph);
		view.removeGraph(graph);
		graph = result.get(0);
		result.remove(graph);
		view.removeGraph(graph);
		List<IGraph> list = view.graphs();
		assertEquals(result, list);
	}

	public void test3() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		List<IGraph> result = new ArrayList<IGraph>();
		for (int i = 0; i < functions.length; i++) {
			IGraph g = GraphFactory.createGraph(FunctionFactory
					.createFunction(functions[i]), 0, 0, 0, null, true);
			result.add(g);
			view.addGraph(g);
		}
		for (int i = 0; i < functions.length; i++) {
			IGraph f = result.get(0);
			result.remove(f);
			view.removeGraph(f);
		}
		List<IGraph> list = view.graphs();
		assertEquals(result, list);
	}

}
