package org.amse.chekh.paint_graph.tests.function_tests;

import org.amse.chekh.paint_graph.model.IFunction;
import org.amse.chekh.paint_graph.model.impl.FunctionFactory;

import junit.framework.TestCase;

public class IsValidTests extends TestCase {

	public void test1() {
		IFunction f = FunctionFactory.createFunction("0.0");
		assertTrue(f.isValid());
	}

	public void test2() {
		IFunction f = FunctionFactory.createFunction("x");
		assertTrue(f.isValid());
	}

	public void test3() {
		IFunction f = FunctionFactory.createFunction("x+x");
		assertTrue(f.isValid());
	}

	public void test4() {
		IFunction f = FunctionFactory.createFunction("x-x");
		assertTrue(f.isValid());
	}

	public void test5() {
		IFunction f = FunctionFactory.createFunction("x*x");
		assertTrue(f.isValid());
	}

	public void test6() {
		IFunction f = FunctionFactory.createFunction("x/x");
		assertTrue(f.isValid());
	}

	public void test7() {
		IFunction f = FunctionFactory.createFunction("x^x");
		assertTrue(f.isValid());
	}

	public void test8() {
		IFunction f = FunctionFactory.createFunction("sin(x)");
		assertTrue(f.isValid());
	}

	public void test9() {
		IFunction f = FunctionFactory.createFunction("exp(x)");
		assertTrue(f.isValid());
	}

	public void test10() {
		IFunction f = FunctionFactory.createFunction("x^(sin(x)+x)/2.0");
		assertTrue(f.isValid());
	}

	public void test11() {
		IFunction f = FunctionFactory.createFunction("x+");
		assertFalse(f.isValid());
	}

	public void test12() {
		IFunction f = FunctionFactory.createFunction("y+x");
		assertFalse(f.isValid());
	}

	public void test13() {
		IFunction f = FunctionFactory.createFunction("(x+x");
		assertFalse(f.isValid());
	}

	public void test14() {
		IFunction f = FunctionFactory.createFunction("x+x)");
		assertFalse(f.isValid());
	}

	public void test15() {
		IFunction f = FunctionFactory.createFunction("sincos(x)/x+x");
		assertFalse(f.isValid());
	}

	public void test16() {
		IFunction f = FunctionFactory.createFunction("0,1");
		assertFalse(f.isValid());
	}

	public void test17() {
		IFunction f = FunctionFactory.createFunction("sin()/x+x");
		assertFalse(f.isValid());
	}

	public void test18() {
		IFunction f = FunctionFactory.createFunction("sin(x)/()+x+x");
		assertFalse(f.isValid());
	}

	public void test19() {
		IFunction f = FunctionFactory.createFunction("sin(x)/(+x+x)");
		assertFalse(f.isValid());
	}

	public void test20() {
		IFunction f = FunctionFactory.createFunction("sin(x)/(x+x*)");
		assertFalse(f.isValid());
	}

	public void test21() {
		IFunction f = FunctionFactory.createFunction("");
		assertFalse(f.isValid());
	}

	public void test22() {
		IFunction f = FunctionFactory.createFunction("x2");
		assertTrue(f.isValid());
	}

	public void test23() {
		IFunction f = FunctionFactory.createFunction("2x");
		assertTrue(f.isValid());
	}

	public void test24() {
		IFunction f = FunctionFactory.createFunction("xx");
		assertTrue(f.isValid());
	}

	public void test25() {
		IFunction f = FunctionFactory.createFunction("(-5)(-x)");
		assertTrue(f.isValid());
	}

	public void test26() {
		IFunction f = FunctionFactory.createFunction("x(-5)");
		assertTrue(f.isValid());
	}

	public void test27() {
		IFunction f = FunctionFactory.createFunction("5(x+x)");
		assertTrue(f.isValid());
	}

	public void test28() {
		IFunction f = FunctionFactory.createFunction("2.5x2");
		assertTrue(f.isValid());
	}

	public void test29() {
		IFunction f = FunctionFactory.createFunction("(-x)5");
		assertTrue(f.isValid());
	}

	public void test30() {
		IFunction f = FunctionFactory.createFunction("xsin(x)");
		assertTrue(f.isValid());
	}

	public void test31() {
		IFunction f = FunctionFactory.createFunction("5cos(x)");
		assertTrue(f.isValid());
	}

	public void test32() {
		IFunction f = FunctionFactory.createFunction("(-5)tan(x)");
		assertTrue(f.isValid());
	}

	public void test33() {
		IFunction f = FunctionFactory.createFunction("xx/x*xx^x");
		assertTrue(f.isValid());
	}
	
	public void test34() {
		IFunction f = FunctionFactory.createFunction("x2x");
		assertTrue(f.isValid());
	}
	
}
