package org.amse.chekh.paint_graph.tests.graph_tests;

import java.awt.Color;

import org.amse.chekh.paint_graph.abstact_view.IGraph;
import org.amse.chekh.paint_graph.abstact_view.impl.GraphFactory;
import org.amse.chekh.paint_graph.model.IFunction;
import org.amse.chekh.paint_graph.model.impl.FunctionFactory;

import junit.framework.TestCase;

public class GetFunctionTests extends TestCase {

	public void test1() {
		IFunction f = FunctionFactory.createFunction("x");
		IGraph g = GraphFactory.createGraph(f, -11.1, 10.0, 100, Color.BLACK,
				true);
		assertEquals(f, g.getFunction());
	}

	public void test2() {
		IFunction f = FunctionFactory.createFunction("x+x");
		IGraph g = GraphFactory.createGraph(f, 23.34, 44.0, 100, Color.BLUE,
				true);
		assertEquals(f, g.getFunction());
	}

	public void test3() {
		IFunction f = FunctionFactory.createFunction("x*x");
		IGraph g = GraphFactory.createGraph(f, 0.0, 10.0, 100, Color.RED, true);
		assertEquals(f, g.getFunction());
	}

}
