package org.amse.chekh.paint_graph.tests.graph_tests;

import java.awt.Color;

import junit.framework.TestCase;

import org.amse.chekh.paint_graph.abstact_view.IAbstractView;
import org.amse.chekh.paint_graph.abstact_view.IGraph;
import org.amse.chekh.paint_graph.abstact_view.impl.AbstractViewFactory;
import org.amse.chekh.paint_graph.abstact_view.impl.GraphFactory;

public class IsGraphSelectedTests extends TestCase {

	public void test1() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		IGraph g = GraphFactory.createGraph(null, -11.1, 10.0, 100, Color.BLACK, true);
		view.addGraph(g);
		if (!g.isGraphSelected()) {
			view.changeGraphSelected(g);
		}
		assertTrue(g.isGraphSelected());
	}

	public void test2() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		IGraph g = GraphFactory.createGraph(null, -11.1, 10.0, 100, Color.BLACK, true);
		view.addGraph(g);
		if (g.isGraphSelected()) {
			view.changeGraphSelected(g);
		}
		assertFalse(g.isGraphSelected());
	}

}
