package org.amse.chekh.paint_graph.tests.writer_tests;

import java.awt.Color;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import org.amse.chekh.paint_graph.abstact_view.IAbstractView;
import org.amse.chekh.paint_graph.abstact_view.IGraph;
import org.amse.chekh.paint_graph.abstact_view.impl.AbstractViewFactory;
import org.amse.chekh.paint_graph.abstact_view.impl.GraphFactory;
import org.amse.chekh.paint_graph.io.writer.Writer;
import org.amse.chekh.paint_graph.model.impl.FunctionFactory;

import junit.framework.TestCase;

public class WriterTests extends TestCase {

	public void test1() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		IGraph g = GraphFactory.createGraph(
				FunctionFactory.createFunction("x"), -10, 10, 1000,
				Color.BLACK, true);
		view.addGraph(g);
		try {
			new Writer(System.getProperty("user.dir") + File.separatorChar
					+ "org" + File.separatorChar + "amse" + File.separatorChar
					+ "chekh" + File.separatorChar + "paint_graph"
					+ File.separatorChar + "tests" + File.separatorChar
					+ "writer_tests" + File.separatorChar + "1.res", view,
					-10.0, 10.0, -10.0, 10.0).write();
			BufferedReader res = new BufferedReader(new FileReader(System
					.getProperty("user.dir")
					+ File.separatorChar
					+ "org"
					+ File.separatorChar
					+ "amse"
					+ File.separatorChar
					+ "chekh"
					+ File.separatorChar
					+ "paint_graph"
					+ File.separatorChar
					+ "tests"
					+ File.separatorChar
					+ "writer_tests"
					+ File.separatorChar
					+ "1.res"));
			BufferedReader correctAns = new BufferedReader(new FileReader(
					System.getProperty("user.dir") + File.separatorChar + "org"
							+ File.separatorChar + "amse" + File.separatorChar
							+ "chekh" + File.separatorChar + "paint_graph"
							+ File.separatorChar + "tests" + File.separatorChar
							+ "writer_tests" + File.separatorChar + "1.ans"));
			String resS = res.readLine();
			String correctAnsS = correctAns.readLine();
			int i = 1;
			while (resS != null && correctAnsS != null) {
				assertEquals("    " + i,
						correctAnsS, resS);
				resS = res.readLine();
				correctAnsS = correctAns.readLine();
				i++;
			}
			if (correctAnsS != null) {
				fail("     ");
			} else if (resS != null) {
				fail("    ");

			}
		} catch (IOException ex) {
		} catch (ParserConfigurationException ex) {
		} catch (TransformerException ex) {
		}
	}

	public void test2() {
		IAbstractView view = AbstractViewFactory.createAbsractView();
		IGraph g = GraphFactory.createGraph(FunctionFactory
				.createFunction("x*x"), -5.0, 6.0, 100, Color.RED, true);
		view.addGraph(g);
		g = GraphFactory.createGraph(FunctionFactory.createFunction("1/x"),
				-1.0, 1.0, 20000, Color.BLACK, true);
		view.addGraph(g);
		g = GraphFactory.createGraph(FunctionFactory
				.createFunction("-sqrt(abs(x))"), -100.25, 200.25, 1000,
				Color.BLUE, true);
		view.addGraph(g);
		g = GraphFactory.createGraph(FunctionFactory.createFunction("4"),
				-10.0, 10.0, 5, Color.YELLOW, false);
		view.addGraph(g);
		g = GraphFactory.createGraph(FunctionFactory.createFunction("f"),
				-12.34, 12.34, 1234, Color.GREEN, false);
		view.addGraph(g);
		try {
			new Writer(System.getProperty("user.dir") + File.separatorChar
					+ "org" + File.separatorChar + "amse" + File.separatorChar
					+ "chekh" + File.separatorChar + "paint_graph"
					+ File.separatorChar + "tests" + File.separatorChar
					+ "writer_tests" + File.separatorChar + "2.res", view,
					20.0, 102.01, -10.5, -5.5).write();
			BufferedReader res = new BufferedReader(new FileReader(System
					.getProperty("user.dir")+ File.separatorChar + "org" 
					+ File.separatorChar + "amse" + File.separatorChar 
					+ "chekh" + File.separatorChar + "paint_graph"
					+ File.separatorChar + "tests" + File.separatorChar 
					+ "writer_tests" + File.separatorChar + "2.res"));
			BufferedReader correctAns = new BufferedReader(new FileReader(
					System.getProperty("user.dir") + File.separatorChar + "org"
							+ File.separatorChar + "amse" + File.separatorChar
							+ "chekh" + File.separatorChar + "paint_graph"
							+ File.separatorChar + "tests" + File.separatorChar
							+ "writer_tests" + File.separatorChar + "2.ans"));
			String resS = res.readLine();
			String correctAnsS = correctAns.readLine();
			int i = 1;
			while (resS != null && correctAnsS != null) {
				assertEquals("    " + i,
						correctAnsS, resS);
				resS = res.readLine();
				correctAnsS = correctAns.readLine();
				i++;
			}
			if (correctAnsS != null) {
				fail("     ");
			} else if (resS != null) {
				fail("    ");

			}
		} catch (IOException ex) {
		} catch (ParserConfigurationException ex) {
		} catch (TransformerException ex) {
		}

	}

}
