package org.amse.chekh.paint_graph.view.dialogs;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import org.amse.chekh.paint_graph.abstact_view.IGraphProperties;
import org.amse.chekh.paint_graph.model.IFunction;
import org.amse.chekh.paint_graph.model.impl.FunctionFactory;

/**
 *     ,    .  
 *  
 * 
 * @author 
 * 
 */
public class AddFunctionDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	/**
	 *    
	 */
	private JTextField myFunctionField = new JTextField(20);

	/**
	 *  -
	 */
	private JTabbedPane myMainPanel = new JTabbedPane();

	/**
	 *         ()
	 */
	private Box myMainProperties;

	/**
	 *      -   
	 *  X    
	 */
	private Box mySecondProperties;

	/**
	 *  
	 */
	private JComboBox myColorComboBox;

	/**
	 *  
	 */
	private static final Color[] myColors = { Color.BLACK, Color.BLUE,
			Color.GREEN, Color.RED };

	/**
	 *      x 
	 */
	private JTextField myMinXField = new JTextField(10);

	/**
	 *      x 
	 */
	private JTextField myMaxXField = new JTextField(10);

	/**
	 *     ,   
	 */
	private JTextField myCountOfSegmentField = new JTextField(10);

	private IFunction myFunction;

	/**
	 *       
	 * 
	 * @param owner
	 */
	public AddFunctionDialog(JFrame owner) {
		super(owner, " ", true);

		this.setLocation(new Point((int) (owner.getLocation().getX() + 100),
				(int) (owner.getLocation().getY() + 100)));

		this.setResizable(false);

		this.setFunction("");
		this.myMinXField.setText("-10.0");
		this.myMaxXField.setText("10.0");
		this.myCountOfSegmentField.setText("1000");

		this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(new WindowAdapter() {

			public void windowClosing(WindowEvent we) {
				AddFunctionDialog.this.myFunction = null;
				AddFunctionDialog.this.setVisible(false);
			}

		});

		this.myFunctionField.setMaximumSize(this.myFunctionField
				.getPreferredSize());
		Box functionBox = Box.createHorizontalBox();
		functionBox.add(new JLabel("Y = "));
		functionBox.add(Box.createHorizontalStrut(5));
		functionBox.add(this.myFunctionField);

		this.myColorComboBox = new JComboBox(myColors);
		this.myColorComboBox.setRenderer(new ColorComboBoxCellRenderer());
		this.myColorComboBox.setMaximumRowCount(5);
		Box colorBox = Box.createHorizontalBox();
		colorBox.add(new JLabel(": "));
		colorBox.add(Box.createHorizontalStrut(5));
		colorBox.add(this.myColorComboBox);

		this.myMainProperties = Box.createVerticalBox();
		this.myMainProperties.setBorder(BorderFactory.createEmptyBorder(12, 12,
				12, 12));
		this.myMainProperties.add(functionBox);
		this.myMainProperties.add(Box.createVerticalStrut(12));
		this.myMainProperties.add(colorBox);

		Box minXBox = Box.createHorizontalBox();
		JLabel l1 = new JLabel(" X");
		minXBox.add(l1);
		minXBox.add(Box.createHorizontalStrut(5));
		minXBox.add(this.myMinXField);

		Box maxXBox = Box.createHorizontalBox();
		JLabel l2 = new JLabel(" X");
		maxXBox.add(l2);
		maxXBox.add(Box.createHorizontalStrut(5));
		maxXBox.add(this.myMaxXField);

		Box segmentBox = Box.createHorizontalBox();
		JLabel l3 = new JLabel(" ");
		segmentBox.add(l3);
		segmentBox.add(Box.createHorizontalStrut(5));
		segmentBox.add(this.myCountOfSegmentField);

		l1.setPreferredSize(l3.getPreferredSize());
		l1.setMinimumSize(l3.getPreferredSize());
		l1.setMaximumSize(l3.getPreferredSize());
		l2.setPreferredSize(l3.getPreferredSize());
		l2.setMinimumSize(l3.getPreferredSize());
		l2.setMaximumSize(l3.getPreferredSize());
		l3.setMinimumSize(l3.getPreferredSize());
		l3.setMaximumSize(l3.getPreferredSize());

		this.mySecondProperties = Box.createVerticalBox();
		this.mySecondProperties.setBorder(BorderFactory.createEmptyBorder(12,
				12, 12, 12));
		this.mySecondProperties.add(minXBox);
		this.mySecondProperties.add(Box.createVerticalStrut(5));
		this.mySecondProperties.add(maxXBox);
		this.mySecondProperties.add(Box.createVerticalStrut(5));
		this.mySecondProperties.add(segmentBox);

		this.myMainPanel.add("", this.myMainProperties);
		this.myMainPanel.add(". ", this.mySecondProperties);

		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT, 0, 0));
		JPanel grid = new JPanel(new GridLayout(1, 2, 5, 0));

		JButton ok = new JButton("OK");
		JButton cancel = new JButton("Cancel");
		grid.add(ok);
		ok.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				AddFunctionDialog.this.enter();
			}

		});
		grid.add(cancel);
		cancel.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				AddFunctionDialog.this.myFunction = null;
				AddFunctionDialog.this.setVisible(false);
			}

		});

		buttonPanel.add(grid);

		Box main = Box.createVerticalBox();
		main.setBorder(BorderFactory.createEmptyBorder(12, 12, 12, 12));
		main.add(this.myMainPanel);
		main.add(Box.createVerticalStrut(12));
		main.add(buttonPanel);
		buttonPanel.setBackground(main.getBackground());
		setContentPane(main);

		InputMap im = this.getRootPane().getInputMap(
				JComponent.WHEN_IN_FOCUSED_WINDOW);
		ActionMap am = this.getRootPane().getActionMap();
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "Enter");
		am.put("Enter", new AbstractAction() {
		
			private static final long serialVersionUID = 1L;

			public void actionPerformed(ActionEvent e) {
				AddFunctionDialog.this.enter();
			}
		
		});
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "Escape");
		am.put("Escape", new AbstractAction() {
		
			private static final long serialVersionUID = 1L;

			public void actionPerformed(ActionEvent e) {
				AddFunctionDialog.this.myFunction = null;
				AddFunctionDialog.this.setVisible(false);
			}
		
		});

		pack();

	}

	public IFunction createFunction(boolean isFunctionFixed) {
		if (isFunctionFixed) {
			this.myFunctionField.setEditable(true);
		} else {
			this.myFunctionField.setEditable(false);
		}
		this.myMainPanel.setSelectedIndex(0);
		this.myFunctionField.requestFocus();
		this.myFunctionField.selectAll();
		this.setVisible(true);
		return this.myFunction;
	}

	public void setFunction(String newFunction) {
		this.myFunctionField.setText(newFunction);
	}

	public void setProperties(IGraphProperties properties) {
		if (properties == null) {
			this.myMinXField.setText("-10");
			this.myMaxXField.setText("10");
			this.myCountOfSegmentField.setText("1000");
			this.myColorComboBox.setSelectedItem(Color.BLACK);
			return;
		}
		this.myMinXField.setText(properties.getMinimumX() + "");
		this.myMaxXField.setText(properties.getMaximumX() + "");
		this.myCountOfSegmentField.setText(properties.getCountOfSegment() + "");
		this.myColorComboBox.setSelectedItem(properties.getColor());
	}

	public double getMinX() {
		return Double.parseDouble(this.myMinXField.getText());
	}

	public double getMaxX() {
		return Double.parseDouble(this.myMaxXField.getText());
	}

	public int getCountOfSegment() {
		return Integer.parseInt(this.myCountOfSegmentField.getText());
	}

	public Color getColor() {
		return (Color) this.myColorComboBox.getSelectedItem();
	}

	private void enter() {
		boolean res = true;
		this.myFunction = FunctionFactory.createFunction(this.myFunctionField
				.getText());
		if (!this.myFunction.isValid()) {
			res = (JOptionPane.showConfirmDialog(this, this.myFunction
					.getErrorMessage()
					+ " ?", "", JOptionPane.YES_NO_OPTION,
					JOptionPane.WARNING_MESSAGE) == JOptionPane.YES_OPTION);
		}
		if (res) {
			try {
				if (Double.parseDouble(this.myMinXField.getText()) >= Double
						.parseDouble(this.myMaxXField.getText())) {
					JOptionPane.showMessageDialog(this,
							" X     X!",
							"", JOptionPane.ERROR_MESSAGE);
					this.myMainPanel.setSelectedIndex(1);
					this.myMinXField.requestFocus();
				} else {
					try {
						if (Integer.parseInt(this.myCountOfSegmentField
								.getText()) > 20000
								|| Integer.parseInt(this.myCountOfSegmentField
										.getText()) <= 0) {
							JOptionPane
									.showMessageDialog(
											this,
											"    ,   20000!",
											"", JOptionPane.ERROR_MESSAGE);
							this.myMainPanel.setSelectedIndex(1);
							this.myCountOfSegmentField.requestFocus();
							this.myCountOfSegmentField.selectAll();
						} else {
							setVisible(false);
						}
					} catch (NumberFormatException ex) {
						JOptionPane.showMessageDialog(this,
								"     !",
								"", JOptionPane.ERROR_MESSAGE);
						this.myMainPanel.setSelectedIndex(1);
						this.myCountOfSegmentField.requestFocus();
						this.myCountOfSegmentField.selectAll();
					}
				}
			} catch (NumberFormatException ex) {
				JOptionPane.showMessageDialog(this,
						"     !", "",
						JOptionPane.ERROR_MESSAGE);
				this.myMainPanel.setSelectedIndex(1);
				this.myMinXField.requestFocus();
				this.myMinXField.selectAll();
			}
		} else {
			this.myMainPanel.setSelectedIndex(0);
			this.myFunctionField.requestFocus();
			this.myFunctionField.selectAll();
		}
	}

	private class ColorComboBoxCellRenderer extends JLabel implements
			ListCellRenderer {

		private static final long serialVersionUID = 1L;

		private Color myColor;

		private ColorComboBoxCellRenderer() {
			this.setPreferredSize(new Dimension(10, 20));
			this.setMinimumSize(getPreferredSize());
			this.setMaximumSize(getPreferredSize());
		}

		public Component getListCellRendererComponent(JList list, Object value,
				int index, boolean isSelected, boolean cellHasFocus) {
			this.setComponentOrientation(list.getComponentOrientation());
			if (isSelected) {
				this.setBackground(list.getSelectionBackground());
				this.setForeground(list.getSelectionForeground());
			} else {
				this.setBackground(list.getBackground());
				this.setForeground(list.getForeground());
			}
			this.myColor = (Color) value;
			return this;
		}

		@Override
		public void paintComponent(Graphics g) {
			g.setColor(getBackground());
			g.fillRect(0, 0, getWidth(), getHeight());
			g.setColor(this.myColor);
			g.drawLine(5, getHeight() / 2, getWidth() - 5, getHeight() / 2);
		}

	}

}
