package org.amse.chekh.paint_graph.view.dialogs;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;


public class ChangeVisibleIntervalDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private JTextField myMinXField = new JTextField(10);

	private JTextField myMaxXField = new JTextField(10);

	private JTextField myMinYField = new JTextField(10);

	private JTextField myMaxYField = new JTextField(10);

	private boolean myDataIsEnter = false;

	public ChangeVisibleIntervalDialog(JFrame owner) {
		super(owner, " ", true);
		
		this.setLocation(new Point((int) (owner.getLocation().getX() + 100),
				(int) (owner.getLocation().getY() + 100)));

		this.setResizable(false);

		this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(new WindowAdapter() {

			public void windowClosing(WindowEvent we) {
				ChangeVisibleIntervalDialog.this.myDataIsEnter = false;
				ChangeVisibleIntervalDialog.this.setVisible(false);
			}

		});

		JPanel properties = new JPanel(new GridLayout(4, 2, 5, 5));
		properties.add(new JLabel(" X"));
		properties.add(this.myMinXField);
		properties.add(new JLabel(" X"));
		properties.add(this.myMaxXField);
		properties.add(new JLabel(" Y"));
		properties.add(this.myMinYField);
		properties.add(new JLabel(" Y"));
		properties.add(this.myMaxYField);

		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT, 0, 0));
		JPanel grid = new JPanel(new GridLayout(1, 2, 5, 0));

		JButton ok = new JButton("OK");
		JButton cancel = new JButton("Cancel");
		grid.add(ok);
		ok.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				ChangeVisibleIntervalDialog.this.enter();
			}

		});
		grid.add(cancel);
		cancel.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				ChangeVisibleIntervalDialog.this.myDataIsEnter = false;
				ChangeVisibleIntervalDialog.this.setVisible(false);
			}

		});

		buttonPanel.add(grid);

		Box main = Box.createVerticalBox();
		main.setBorder(BorderFactory.createEmptyBorder(12, 12, 12, 12));
		main.add(properties);
		properties.setBackground(main.getBackground());
		main.add(Box.createVerticalStrut(12));
		main.add(buttonPanel);
		buttonPanel.setBackground(main.getBackground());
		setContentPane(main);

		InputMap im = this.getRootPane().getInputMap(
				JComponent.WHEN_IN_FOCUSED_WINDOW);
		ActionMap am = this.getRootPane().getActionMap();
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "Enter");
		am.put("Enter", new AbstractAction() {
		
			private static final long serialVersionUID = 1L;

			public void actionPerformed(ActionEvent e) {
				ChangeVisibleIntervalDialog.this.enter();
			}
		
		});
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "Escape");
		am.put("Escape", new AbstractAction() {
		
			private static final long serialVersionUID = 1L;

			public void actionPerformed(ActionEvent e) {
				ChangeVisibleIntervalDialog.this.myDataIsEnter = false;
				ChangeVisibleIntervalDialog.this.setVisible(false);
			}
		
		});

		pack();

	}
	
	public boolean show(double minX, double maxX, double minY, double maxY) {
		this.myMinXField.setText(Math.ceil(minX * 1000) / 1000 + "");
		this.myMaxXField.setText(Math.ceil(maxX * 1000) / 1000 + "");
		this.myMinYField.setText(Math.ceil(minY * 1000) / 1000 + "");
		this.myMaxYField.setText(Math.ceil(maxY * 1000) / 1000 + "");
		this.setVisible(true);
		return this.myDataIsEnter;
	}
	
	public double getMinX() {
		return Double.parseDouble(this.myMinXField.getText());
	}
	
	public double getMaxX() {
		return Double.parseDouble(this.myMaxXField.getText());
	}
	
	public double getMinY() {
		return Double.parseDouble(this.myMinYField.getText());
	}
	
	public double getMaxY() {
		return Double.parseDouble(this.myMaxYField.getText());
	}
	
	private void enter() {
		try {
			Double.parseDouble(this.myMinXField.getText());
		} catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this,
					"     !", "",
					JOptionPane.ERROR_MESSAGE);
			this.myMinXField.requestFocus();
			this.myMinXField.selectAll();
			return;
		}
		try {
			Double.parseDouble(this.myMaxXField.getText());
		} catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this,
					"     !", "",
					JOptionPane.ERROR_MESSAGE);
			this.myMaxXField.requestFocus();
			this.myMaxXField.selectAll();
			return;
		}
		try {
			Double.parseDouble(this.myMinYField.getText());
		} catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this,
					"     !", "",
					JOptionPane.ERROR_MESSAGE);
			this.myMinYField.requestFocus();
			this.myMinYField.selectAll();
			return;
		}
		try {
			Double.parseDouble(this.myMaxYField.getText());
		} catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this,
					"     !", "",
					JOptionPane.ERROR_MESSAGE);
			this.myMaxYField.requestFocus();
			this.myMaxYField.selectAll();
			return;
		}
		this.myDataIsEnter = true;
		this.setVisible(false);
	}
	
}
